/*
 * Copyright 2006 Maskat Project.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.maskat.ide.action;

import java.util.List;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gef.requests.GroupRequest;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.ui.IWorkbenchPart;
import org.maskat.ide.MaskatIDEPlugin;

public class DelComponentAction extends SelectionAction {

	private static Request request = new GroupRequest(RequestConstants.REQ_DELETE);

	public static final String ID = MaskatIDEPlugin.PLUGIN_ID + ".action.delete";

	public DelComponentAction(IWorkbenchPart part) {
		super(part);
		setId(ID);
		setText("削除");
	}

	protected boolean calculateEnabled() {
		if (getSelectedObjects().isEmpty())
			return false;
		return true;
	}

	private Command getCommand() {
		List editparts = getSelectedObjects();
		CompoundCommand cc = new CompoundCommand();
		cc.setDebugLabel("Delete edit part");//$NON-NLS-1$
		for (int i = 0; i < editparts.size(); i++) {
			EditPart part = (EditPart) editparts.get(i);
			cc.add(part.getCommand(request));
		}
		cc.setLabel("コンポーネント削除");
		return cc;
	}

	public void run() {
		execute(getCommand());
	}
}
